/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *		sil.h̃vZbTˑiRX630pj
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#define TOPPERS_OMIT_SIL_ACCESS

#ifndef TOPPERS_MACRO_ONLY
#include "prc_insn.h"


/*
 *  S݋֎~
 */
Inline uint32_t
TOPPERS_disint( void )
{
	volatile uint32_t	TOPPERS_psw;

	TOPPERS_psw = current_psw();
	disint();

	return( TOPPERS_psw );
}


/*
 *  S݋
 */
Inline void
TOPPERS_enaint( uint32_t TOPPERS_psw )
{
	if( TOPPERS_psw & PSW_I_MASK ){
		enaint();
	}
}


/*
 *  S݃bNԂ̐
 */
#define SIL_PRE_LOC		uint32_t TOPPERS_i_psw;
#define SIL_LOC_INT()	( ( void )( TOPPERS_i_psw = TOPPERS_disint() ) )
#define SIL_UNL_INT()	( TOPPERS_enaint( TOPPERS_i_psw ) )


/*
 *  GfBA̔]
 *
 *  {Jł̓GfBAϊ߂݂邽,
 *  A[LeN`ˑɂă}N㏑.
 */
#define TOPPERS_SIL_REV_ENDIAN_UINT16( data )	\
 								rev_endian_uint16( data )
#define TOPPERS_SIL_REV_ENDIAN_UINT32( data )	\
 								rev_endian_uint32( data )


/*
 *  ԑ҂
 */
extern void sil_dly_nse( ulong_t dlytim );

#endif /* TOPPERS_MACRO_ONLY */


/*
 *  vZbT̃GfBA
 */
#ifdef __LIT
#define SIL_ENDIAN_LITTLE			/* gGfBA */
#endif
#ifdef __BIG
#define SIL_ENDIAN_BIG				/* rbOGfBA */
#endif


/*
 *  8rbgPʂ̓Ǐo^
 */
#ifdef UINT8_MAX

#pragma inline(sil_reb_mem)
static uint8_t
sil_reb_mem(const volatile uint8_t __evenaccess *mem)
{
	uint8_t	data;

	data = *mem;
	return(data);
}

#pragma inline(sil_wrb_mem)
static void
sil_wrb_mem(volatile uint8_t __evenaccess *mem, uint8_t data)
{
	*mem = data;
}

#endif /* UINT8_MAX */

/*
 *  16rbgPʂ̓Ǐo^
 */

#pragma inline(sil_reh_mem)
static uint16_t
sil_reh_mem(const volatile uint16_t __evenaccess *mem)
{
	uint16_t	data;

	data = *mem;
	return(data);
}

#pragma inline(sil_wrh_mem)
static void
sil_wrh_mem(volatile uint16_t __evenaccess *mem, uint16_t data)
{
	*mem = data;
}

#ifdef SIL_ENDIAN_BIG			/* rbOGfBAvZbT */

#define	sil_reh_bem(mem)		sil_reh_mem(mem)
#define	sil_wrh_bem(mem, data)	sil_wrh_mem(mem, data)

#ifndef TOPPERS_OMIT_SIL_REH_LEM

#pragma inline(sil_reh_lem)
static uint16_t
sil_reh_lem(const volatile uint16_t __evenaccess *mem)
{
	uint16_t	data;

	data = *mem;
	return(TOPPERS_SIL_REV_ENDIAN_UINT16(data));
}

#endif /* TOPPERS_OMIT_SIL_REH_LEM */
#ifndef TOPPERS_OMIT_SIL_WRH_LEM

#pragma inline(sil_wrh_lem)
static void
sil_wrh_lem(volatile uint16_t __evenaccess *mem, uint16_t data)
{
	*mem = TOPPERS_SIL_REV_ENDIAN_UINT16(data);
}

#endif /* TOPPERS_OMIT_SIL_WRH_LEM */
#else /* SIL_ENDIAN_BIG */
#ifdef SIL_ENDIAN_LITTLE		/* gGfBAvZbT */

#define	sil_reh_lem(mem)		sil_reh_mem(mem)
#define	sil_wrh_lem(mem, data)	sil_wrh_mem(mem, data)

#ifndef TOPPERS_OMIT_SIL_REH_BEM

#pragma inline(sil_reh_bem)
static uint16_t
sil_reh_bem(const volatile uint16_t __evenaccess *mem)
{
	uint16_t	data;

	data = *mem;
	return(TOPPERS_SIL_REV_ENDIAN_UINT16(data));
}

#endif /* TOPPERS_OMIT_SIL_REH_BEM */
#ifndef TOPPERS_OMIT_SIL_WRH_BEM

#pragma inline(sil_wrh_bem)
static void
sil_wrh_bem(volatile uint16_t __evenaccess *mem, uint16_t data)
{
	*mem = TOPPERS_SIL_REV_ENDIAN_UINT16(data);
}

#endif /* TOPPERS_OMIT_SIL_WRH_BEM */
#else /* SIL_ENDIAN_LITTLE */

#error Neither SIL_ENDIAN_BIG nor SIL_ENDIAN_LITTLE is defined.

#endif /* SIL_ENDIAN_LITTLE */
#endif /* SIL_ENDIAN_BIG */

/*
 *  32rbgPʂ̓Ǐo^
 */

#pragma inline(sil_rew_mem)
static uint32_t
sil_rew_mem(const volatile uint32_t __evenaccess *mem)
{
	uint32_t	data;

	data = *mem;
	return(data);
}

#pragma inline(sil_wrw_mem)
static void
sil_wrw_mem(volatile uint32_t __evenaccess *mem, uint32_t data)
{
	*mem = data;
}

#ifdef SIL_ENDIAN_BIG			/* rbOGfBAvZbT */

#define	sil_rew_bem(mem)		sil_rew_mem(mem)
#define	sil_wrw_bem(mem, data)	sil_wrw_mem(mem, data)

#ifndef TOPPERS_OMIT_SIL_REW_LEM

#pragma inline(sil_rew_lem)
static uint32_t
sil_rew_lem(const volatile uint32_t __evenaccess *mem)
{
	uint32_t	data;

	data = *mem;
	return(TOPPERS_SIL_REV_ENDIAN_UINT32(data));
}

#endif /* TOPPERS_OMIT_SIL_REW_LEM */
#ifndef TOPPERS_OMIT_SIL_WRW_LEM

#pragma inline(sil_wrw_lem)
static void
sil_wrw_lem(volatile uint32_t __evenaccess *mem, uint32_t data)
{
	*mem = TOPPERS_SIL_REV_ENDIAN_UINT32(data);
}

#endif /* TOPPERS_OMIT_SIL_WRW_LEM */
#else /* SIL_ENDIAN_BIG */		/* gGfBAvZbT */

#define	sil_rew_lem(mem)		sil_rew_mem(mem)
#define	sil_wrw_lem(mem, data)	sil_wrw_mem(mem, data)

#ifndef TOPPERS_OMIT_SIL_REW_BEM

#pragma inline(sil_rew_bem)
static uint32_t
sil_rew_bem(const volatile uint32_t __evenaccess *mem)
{
	uint32_t	data;

	data = *mem;
	return(TOPPERS_SIL_REV_ENDIAN_UINT32(data));
}

#endif /* TOPPERS_OMIT_SIL_REW_BEM */
#ifndef TOPPERS_OMIT_SIL_WRW_BEM

#pragma inline(sil_wrw_bem)
static void
sil_wrw_bem(volatile uint32_t __evenaccess *mem, uint32_t data)
{
	*mem = TOPPERS_SIL_REV_ENDIAN_UINT32(data);
}

#endif /* TOPPERS_OMIT_SIL_WRW_BEM */
#endif /* SIL_ENDIAN_BIG */

#endif /* TOPPERS_PRC_SIL_H */
